classification
Title: window x64 c-extensions not works on python3.4.0b2
Type: compile error Stage: resolved
Components: Build, Windows Versions: Python 3.4
process
Status: closed Resolution: fixed
Dependencies: Superseder: test_distutils warning: initfunc exported twice on Windows
View: 9709
Assigned To: Nosy List: brian.curtin, giampaolo.rodola, jarod, jkloth, larry, loewis, skrah, tim.golden
Priority: release blocker Keywords:

Created on 2014-01-07 19:48 by jarod, last changed 2014-02-02 15:27 by jkloth. This issue is now closed.

Messages (6)
msg207584 - (view) Author: jarod (jarod) Date: 2014-01-07 19:48
After installing python3.4.0b2.amd64 and rebuild modules, most of them stoped works. List of modules is [psutil, ujson].
Exception occurs on importing module:

import error: dynamic module does not define init function PyInit_<module_name>

and I found solution (workaround) - need change declaration of init function:

Line:
PyObject *PyInit_<module_name>(void)

was changed to:
PyMODINIT_FUNC PyInit_<module_name>(void)

and module works fine after rebuild.


All works fine with 3.4.0b1 and all alpha versions.
I have windows8.1 x64.
msg207610 - (view) Author: Stefan Krah (skrah) * (Python committer) Date: 2014-01-07 22:18
Thanks for the report! -- That's due to the commit in #9709.
PyMODINIT_FUNC is more than ten years old, so I hoped people
would be using by now.


On the other hand that's serious breakage.  Martin, would you
have time to make a call on whether to revert the change?
msg209527 - (view) Author: Stefan Krah (skrah) * (Python committer) Date: 2014-01-28 10:20
Ping. The blocker seems to have passed beta3. :)
msg209538 - (view) Author: Martin v. Löwis (loewis) * (Python committer) Date: 2014-01-28 12:27
I think the change should be reverted, and the original issue closed as "won't fix".

Alternatively, to fix the original issue, the specific linker warning could be suppressed.
msg209549 - (view) Author: Stefan Krah (skrah) * (Python committer) Date: 2014-01-28 14:13
Thanks, that seems to be the best course of action.  Fixed in
69827c2ab9d0.
msg209991 - (view) Author: Jeremy Kloth (jkloth) * Date: 2014-02-02 15:27
Issue #16779 has a patch that suppresses the warning for 64-bit builds that would also "fix" #9709.
History
Date User Action Args
2014-02-02 15:27:22jklothsetnosy: + jkloth
messages: + msg209991
2014-01-28 14:13:20skrahsetstatus: open -> closed
superseder: test_distutils warning: initfunc exported twice on Windows
messages: + msg209549

type: compile error
resolution: fixed
stage: resolved
2014-01-28 12:27:21loewissetmessages: + msg209538
2014-01-28 10:20:21skrahsetmessages: + msg209527
2014-01-08 21:25:48giampaolo.rodolasetnosy: + giampaolo.rodola
2014-01-07 22:18:45skrahsetpriority: normal -> release blocker
nosy: + larry, skrah, loewis
messages: + msg207610

2014-01-07 20:46:48pitrousetnosy: + tim.golden, brian.curtin
2014-01-07 19:48:38jarodcreate